## src_stable_14.tar.xz

=== Makefile ===
#
#
# The common user-driven targets are (for a complete list, see build(7)):
#
# universe            - *Really* build *everything* (buildworld and
#                       all kernels on all architectures).  Define
#                       MAKE_JUST_KERNELS or WITHOUT_WORLDS to only build kernels,
#                       MAKE_JUST_WORLDS or WITHOUT_KERNELS to only build userland.
# tinderbox           - Same as universe, but presents a list of failed build
#                       targets and exits with an error if there were any.
# worlds	      - Same as universe, except just makes the worlds.
# kernels	      - Same as universe, except just makes the kernels.
# buildworld          - Rebuild *everything*, including glue to help do
#                       upgrades.
# installworld        - Install everything built by "buildworld".
# world               - buildworld + installworld, no kernel.
# buildkernel         - Rebuild the kernel and the kernel-modules.
# installkernel       - Install the kernel and the kernel-modules.
# installkernel.debug
# reinstallkernel     - Reinstall the kernel and the kernel-modules.
# reinstallkernel.debug
# kernel              - buildkernel + installkernel.
# kernel-toolchain    - Builds the subset of world necessary to build a kernel
# kernel-toolchains   - Build kernel-toolchain for all universe targets.
# doxygen             - Build API documentation of the kernel, needs doxygen.
# checkworld          - Run test suite on installed world.
# check-old           - List obsolete directories/files/libraries.
# check-old-dirs      - List obsolete directories.
# check-old-files     - List obsolete files.
# check-old-libs      - List obsolete libraries.
# delete-old          - Delete obsolete directories/files.
# delete-old-dirs     - Delete obsolete directories.
# delete-old-files    - Delete obsolete files.
# delete-old-libs     - Delete obsolete libraries.
# list-old-dirs       - Raw list of possibly obsolete directories.
# list-old-files      - Raw list of possibly obsolete files.
# list-old-libs       - Raw list of possibly obsolete libraries.
# targets             - Print a list of supported TARGET/TARGET_ARCH pairs
#                       for world and kernel targets.
# toolchains          - Build a toolchain for all world and kernel targets.
# makeman             - Regenerate src.conf(5)
# sysent              - (Re)build syscall entries from syscalls.master.
# xdev                - xdev-build + xdev-install for the architecture
#                       specified with TARGET and TARGET_ARCH.
# xdev-build          - Build cross-development tools.
# xdev-install        - Install cross-development tools.
# xdev-links          - Create traditional links in /usr/bin for cc, etc
# native-xtools       - Create host binaries that produce target objects
#                       for use in qemu user-mode jails.  TARGET and
#                       TARGET_ARCH should be defined.
# native-xtools-install
#                     - Install the files to the given DESTDIR/NXTP where
#                       NXTP defaults to /nxb-bin.
#
# This makefile is simple by design. The FreeBSD make automatically reads
# the /usr/share/mk/sys.mk unless the -m argument is specified on the
# command line. By keeping this makefile simple, it doesn't matter too
# much how different the installed mk files are from those in the source
# tree. This makefile executes a child make process, forcing it to use
# the mk files from the source tree which are supposed to DTRT.
#
# Most of the user-driven targets (as listed above) are implemented in
# Makefile.inc1.  The exceptions are universe, tinderbox and targets.
#
# If you want to build your system from source, be sure that /usr/obj has
# at least 6 GB of disk space available.  A complete 'universe' build of
# r340283 (2018-11) required 167 GB of space.  ZFS lz4 compression
# achieved a 2.18x ratio, reducing actual space to 81 GB.
#
# For individuals wanting to build from the sources currently on their
# system, the simple instructions are:
#
# 1.  `cd /usr/src'  (or to the directory containing your source tree).
# 2.  Define `HISTORICAL_MAKE_WORLD' variable (see README).
# 3.  `make world'
#
# For individuals wanting to upgrade their sources (even if only a
# delta of a few days):
#
#  1.  `cd /usr/src'       (or to the directory containing your source tree).
#  2.  `make buildworld'
#  3.  `make buildkernel KERNCONF=YOUR_KERNEL_HERE'     (default is GENERIC).
#  4.  `make installkernel KERNCONF=YOUR_KERNEL_HERE'   (default is GENERIC).
#       [steps 3. & 4. can be combined by using the "kernel" target]
#  5.  `reboot'        (in single user mode: boot -s from the loader prompt).
#  6.  `etcupdate -p'
#  7.  `make installworld'
#  8.  `etcupdate -B'
#  9.  `make delete-old'
# 10.  `reboot'
# 11.  `make delete-old-libs' (in case no 3rd party program uses them anymore)
#
# For individuals wanting to build from source with GCC from ports, first
# install the appropriate GCC cross toolchain package:
#   `pkg install ${TARGET_ARCH}-gccN`
#
# Once you have installed the necessary cross toolchain, simply pass
# CROSS_TOOLCHAIN=${TARGET_ARCH}-gccN while building with the above steps,
# e.g., `make buildworld CROSS_TOOLCHAIN=amd64-gcc13`.
#
# The ${TARGET_ARCH}-gccN packages are provided as flavors of the
# devel/freebsd-gccN ports.
#
# See src/UPDATING `COMMON ITEMS' for more complete information.
#
# If TARGET=machine (e.g. powerpc, arm64, ...) is specified you can
# cross build world for other machine types using the buildworld target,
# and once the world is built you can cross build a kernel using the
# buildkernel target.
#
# Define the user-driven targets. These are listed here in alphabetical
# order, but that's not important.
#
# Targets that begin with underscore are internal targets intended for
# developer convenience only.  They are intentionally not documented and
# completely subject to change without notice.
#
# For more information, see the build(7) manual page.
#

# Include jobs.mk early if we need it.
# It will turn:
# 	make buildworld-jobs
# into
# 	make -j${JOB_MAX} buildworld > ../buildworld.log 2>&1
#
.if make(*-jobs)
.include <jobs.mk>
.endif

.if defined(UNIVERSE_TARGET) || defined(MAKE_JUST_WORLDS) || defined(WITHOUT_KERNELS)
__DO_KERNELS=no
.endif
.if defined(MAKE_JUST_KERNELS) || defined(WITHOUT_WORLDS)
__DO_WORLDS=no
.endif
__DO_WORLDS?=yes
__DO_KERNELS?=yes

# This is included so CC is set to ccache for -V, and COMPILER_TYPE/VERSION
# can be cached for sub-makes. We can't do this while still running on the
# old fmake from FreeBSD 9.x or older, so avoid including it then to avoid
# heartburn upgrading from older systems. The need for CC is done with new
# make later in the build, and caching COMPILER_TYPE/VERSION is only an
# optimization. Also sinclude it to be friendlier to foreign OS hosted builds.
.if ${MAKE_VERSION} >= 20140620 && defined(.PARSEDIR)
.sinclude <bsd.compiler.mk>
.endif

# Note: we use this awkward construct to be compatible with FreeBSD's
# old make used in 10.0 and 9.2 and earlier.
.if defined(MK_DIRDEPS_BUILD) && ${MK_DIRDEPS_BUILD} == "yes" && \
    !make(showconfig) && !make(print-dir)
# targets/Makefile plays the role of top-level
.include "targets/Makefile"
.else

.include "${.CURDIR}/share/mk/bsd.compat.pre.mk"

TGTS=	all all-man buildenv buildenvvars buildetc buildkernel buildworld \
	check check-old check-old-dirs check-old-files check-old-libs \
	checkdpadd checkworld clean cleandepend cleandir cleankernel \
	cleanworld cleanuniverse \
	delete-old delete-old-dirs delete-old-files delete-old-libs \
	depend distribute distributekernel distributekernel.debug \
	distributeworld distrib-dirs distribution doxygen \
	everything hier hierarchy install installcheck installetc installkernel \
	installkernel.debug packagekernel packageworld \
	reinstallkernel reinstallkernel.debug \
	installworld kernel-toolchain libraries maninstall \
	list-old-dirs list-old-files list-old-libs \
	obj objlink showconfig tags toolchain \
	makeman sysent \
	_cleanworldtmp _worldtmp _legacy _bootstrap-tools _cleanobj _obj \
	_build-tools _build-metadata _cross-tools _includes _libraries \
	builddtb xdev xdev-build xdev-install \
	xdev-links native-xtools native-xtools-install stageworld stagekernel \
	stage-packages stage-packages-kernel stage-packages-world stage-packages-source \
	create-packages-world create-packages-kernel \
	create-packages-kernel-repo create-packages-world-repo \
	create-packages-source create-packages \
	installconfig real-packages real-update-packages \
	sign-packages package-pkg print-dir test-system-compiler test-system-linker \
	test-includes

.for libcompat in ${_ALL_libcompats}
TGTS+=	build${libcompat} distribute${libcompat} install${libcompat}
.endfor

# These targets require a TARGET and TARGET_ARCH be defined.
XTGTS=	native-xtools native-xtools-install xdev xdev-build xdev-install \
	xdev-links

# XXX: r156740: This can't work since bsd.subdir.mk is not included ever.
# It will only work for SUBDIR_TARGETS in make.conf.
TGTS+=	${SUBDIR_TARGETS}

BITGTS=	files includes
BITGTS:=${BITGTS} ${BITGTS:S/^/build/} ${BITGTS:S/^/install/}
TGTS+=	${BITGTS}

# Only some targets are allowed to use meta mode.  Others get it
# disabled.  In some cases, such as 'install', meta mode can be dangerous
# as a cookie may be used to prevent redundant installations (such as
# for WORLDTMP staging).  For DESTDIR=/ we always want to install though.
# For other cases, such as delete-old-libs, meta mode may break
# the interactive tty prompt.  The safest route is to just whitelist
# the ones that benefit from it.
META_TGT_WHITELIST+= \
	_* buildfiles buildincludes buildkernel \
	buildworld everything kernel-toolchain kernel-toolchains kernel \
	kernels libraries native-xtools showconfig test-includes \
	test-system-compiler test-system-linker tinderbox toolchain \
	toolchains universe universe-toolchain world worlds xdev xdev-build

.for libcompat in ${_ALL_libcompats}
META_TGT_WHITELIST+=	build${libcompat}
.endfor

.ORDER: buildworld installworld
.ORDER: buildworld distrib-dirs
.ORDER: buildworld distribution
.ORDER: buildworld distribute
.ORDER: buildworld distributeworld
.ORDER: buildworld buildkernel
.ORDER: buildworld packages
.ORDER: buildworld update-packages
.ORDER: distrib-dirs distribute
.ORDER: distrib-dirs distributeworld
.ORDER: distrib-dirs installworld
.ORDER: distribution distribute
.ORDER: distributeworld distribute
.ORDER: distributeworld distribution
.ORDER: installworld distribute
.ORDER: installworld distribution
.ORDER: installworld installkernel
.ORDER: buildkernel installkernel
.ORDER: buildkernel installkernel.debug
.ORDER: buildkernel reinstallkernel
.ORDER: buildkernel reinstallkernel.debug
.ORDER: buildkernel packages
.ORDER: buildkernel update-packages
.ORDER: kernel-toolchain buildkernel

# Only sanitize PATH on FreeBSD.
# PATH may include tools that are required to cross-build
# on non-FreeBSD systems.
.if ${.MAKE.OS} == "FreeBSD"
PATH=	/sbin:/bin:/usr/sbin:/usr/bin
.endif
MAKEOBJDIRPREFIX?=	/usr/obj
_MAKEOBJDIRPREFIX!= /usr/bin/env -i PATH=${PATH:Q} ${MAKE} MK_AUTO_OBJ=no \
    ${.MAKEFLAGS:MMAKEOBJDIRPREFIX=*} __MAKE_CONF=${__MAKE_CONF} \
    SRCCONF=${SRCCONF} SRC_ENV_CONF= \
    -f /dev/null -V MAKEOBJDIRPREFIX dummy
.if !empty(_MAKEOBJDIRPREFIX) || !empty(.MAKEOVERRIDES:MMAKEOBJDIRPREFIX)
.error MAKEOBJDIRPREFIX can only be set in environment or src-env.conf(5),\
    not as a global (in make.conf(5) or src.conf(5)) or command-line variable.
.endif

# We often need to use the tree's version of make to build it.
# Choices add to complexity though.
# We cannot blindly use a make which may not be the one we want
# so be explicit - until all choice is removed.
WANT_MAKE=	bmake
.if !empty(.MAKE.MODE:Mmeta)
# 20160604 - support missing-meta,missing-filemon and performance improvements
WANT_MAKE_VERSION= 20160604
.else
# 20160220 - support .dinclude for FAST_DEPEND.

=== bin/Makefile ===
#	From: @(#)Makefile	8.1 (Berkeley) 5/31/93

.include <src.opts.mk>

SUBDIR= cat \
	chflags \
	chio \
	chmod \
	cp \
	cpuset \
	date \
	dd \
	df \
	domainname \
	echo \
	ed \
	expr \
	freebsd-version \
	getfacl \
	hostname \
	kenv \
	kill \
	ln \
	ls \
	mkdir \
	mv \
	nproc \
	pax \
	pkill \
	ps \
	pwait \
	pwd \
	realpath \
	rm \
	rmdir \
	setfacl \
	sh \
	sleep \
	stty \
	sync \
	test \
	timeout \
	uuidgen

SUBDIR.${MK_SENDMAIL}+=	rmail
SUBDIR.${MK_TCSH}+=	csh
SUBDIR.${MK_TESTS}+=	tests

.include <bsd.arch.inc.mk>

SUBDIR_PARALLEL=

.include <bsd.subdir.mk>

=== etc/Makefile ===
#	from: @(#)Makefile	5.11 (Berkeley) 5/21/91

.include <src.opts.mk>
.include <src.tools.mk>

.include <bsd.compat.pre.mk>

FILESGROUPS=	FILES
NLS_ALIASES=	POSIX C \
		en_US.US_ASCII C

# No need as it is empty and just causes rebuilds since this file does so much.
UPDATE_DEPENDFILE=	no

SUBDIR+=termcap
.if ${MK_SENDMAIL} != "no"
SUBDIR+=sendmail
.endif

# NB: keep these sorted by MK_* knobs

ETCMAIL=aliases
.if ${MK_SENDMAIL} != "no"
ETCMAIL_SENDMAIL+=Makefile README access.sample virtusertable.sample \
	mailertable.sample
.endif

# Special top level files for FreeBSD
FREEBSD=COPYRIGHT

# Sanitize DESTDIR
DESTDIR:=	${DESTDIR:C://*:/:g}

afterinstall:
.if ${MK_MAN} != "no"
	${_+_}cd ${SRCTOP}/share/man; ${MAKE} makedb
.endif

distribute:
	# Avoid installing tests here; "make distribution" will do this and
	# correctly place them in the right location.
	${_+_}cd ${.CURDIR} ; ${MAKE} MK_TESTS=no install \
	    DESTDIR=${DISTDIR}/${DISTRIBUTION}
	${_+_}cd ${.CURDIR} ; ${MAKE} distribution DESTDIR=${DISTDIR}/${DISTRIBUTION}

.include <bsd.endian.mk>

.if defined(NO_ROOT)
METALOG.add?=	cat -l >> ${METALOG}
.endif

distribution:
.if !defined(DESTDIR)
	@echo "set DESTDIR before running \"make ${.TARGET}\""
	@false
.endif
	${_+_}cd ${.CURDIR}/gss; ${MAKE} install
	${_+_}cd ${.CURDIR}/mtree; ${MAKE} install
	${_+_}cd ${SRCTOP}/share/termcap; ${MAKE} etc-termcap
	${_+_}cd ${SRCTOP}/usr.sbin/rmt; ${MAKE} etc-rmt
	${INSTALL_SYMLINK} -T "package=runtime" ../var/run/os-release \
		${DESTDIR}/etc/os-release
.if ${MK_UNBOUND} != "no"
	if [ ! -e ${DESTDIR}/etc/unbound ]; then \
		${INSTALL_SYMLINK} -T "package=unbound" \
		../var/unbound ${DESTDIR}/etc/unbound; \
	fi
.endif
.if ${MK_SENDMAIL} != "no"
	${_+_}cd ${.CURDIR}/sendmail; ${MAKE} distribution
.endif
.if ${MK_KERBEROS} != "no"
	cd ${.CURDIR}/root; \
	    ${INSTALL} -o ${BINOWN} -g ${BINGRP} -m 644 \
		-T "package=runtime,config" \
		dot.k5login ${DESTDIR}/root/.k5login;
.endif

.if ${MK_MAIL} != "no"
	cd ${.CURDIR}/mail; ${INSTALL} -o ${BINOWN} -g ${BINGRP} -m 644 \
	    -T "package=runtime,config" ${ETCMAIL} ${DESTDIR}/etc/mail
	if [ -d ${DESTDIR}/etc/mail -a -f ${DESTDIR}/etc/mail/aliases -a \
	      ! -f ${DESTDIR}/etc/aliases ]; then \
		${INSTALL_SYMLINK} -T "package=runtime" \
		mail/aliases ${DESTDIR}/etc/aliases; \
	fi
.endif
.if ${MK_SENDMAIL} != "no"
	cd ${.CURDIR}/mail; ${INSTALL} -o ${BINOWN} -g ${BINGRP} -m 644 \
		-T "package=sendmail" ${ETCMAIL_SENDMAIL} ${DESTDIR}/etc/mail
.endif
	cd ${.CURDIR}/..; ${INSTALL} -o ${BINOWN} -g ${BINGRP} -m 444 \
		-T "package=runtime" ${FREEBSD} ${DESTDIR}/
.if ${MK_BOOT} != "no"
.if exists(${SRCTOP}/sys/${MACHINE}/conf/GENERIC.hints)
	${INSTALL} -o ${BINOWN} -g ${BINGRP} -m 444 \
	    -T "package=bootloader,config" \
	    ${SRCTOP}/sys/${MACHINE}/conf/GENERIC.hints \
	    ${DESTDIR}/boot/device.hints
.endif
.endif

MTREES=		mtree/BSD.root.dist		/		\
		mtree/BSD.var.dist		/var		\
		mtree/BSD.usr.dist		/usr		\
		mtree/BSD.include.dist		/usr/include	\
		mtree/BSD.debug.dist		/usr/lib
.for LIBCOMPAT libcompat in ${_ALL_LIBCOMPATS_libcompats}
.if ${MK_LIB${LIBCOMPAT}} != "no"
MTREES+=	mtree/BSD.lib${libcompat}.dist	/usr
MTREES+=	mtree/BSD.lib${libcompat}.dist	/usr/lib/debug/usr
.endif
.endfor
.if ${MK_TESTS} != "no"
MTREES+=	mtree/BSD.tests.dist		${TESTSBASE}
MTREES+=	mtree/BSD.tests.dist		/usr/lib/debug${TESTSBASE}
.endif
.if ${MK_SENDMAIL} != "no"
MTREES+=	mtree/BSD.sendmail.dist		/
.endif
.for mtree in ${LOCAL_MTREE}
MTREES+=	../${mtree}			/
.endfor

# Clean up files that have changed into directories, as mtree cannot handle this
# scenario.
DISTRIB_CLEANUP_FILES+=	${INCLUDEDIR}/c++/v1/__string
DISTRIB_CLEANUP_FILES+=	${INCLUDEDIR}/c++/v1/__tuple
DISTRIB_CLEANUP_FILES+=	${LIBEXECDIR}/kgdb
distrib-cleanup: .PHONY
	for file in ${DISTRIB_CLEANUP_FILES}; do \
		if [ -f ${DESTDIR}/$${file} ]; then \
			rm -f ${DESTDIR}/$${file}; \
		fi; \
	done

distrib-dirs: ${MTREES:N/*} distrib-cleanup .PHONY
.for _m _d in ${MTREES}
	@m=${.CURDIR}/${_m}; \
	d=${DESTDIR}${_d}; \
	test -d $$d || mkdir -p $$d; \
	${ECHO} ${MTREE_CMD} -deU ${MTREE_FSCHG} \
	    ${MTREE_FOLLOWS_SYMLINKS} -f $$m -p $$d; \
	${MTREE_FILTER} $$m | \
	${MTREE_CMD} -deU ${MTREE_FSCHG} ${MTREE_FOLLOWS_SYMLINKS} \
	    -p $$d
.endfor
.if defined(NO_ROOT)
.for _m _d in ${MTREES}
	@m=${.CURDIR}/${_m}; \
	d=${_d}; \
	test "$$d" = "/" && d=""; \
	d=${DISTBASE}$$d; \
	${ECHO} "${MTREE_CMD:N-W} -C -f $$m -K all | " \
	    "sed s#^\.#.$$d# | ${METALOG.add}" ; \
	${MTREE_FILTER} $$m | \
	${MTREE_CMD:N-W} -C -K all | sed s#^\.#.$$d# | \
	    ${METALOG.add}
.endfor
.endif
.if ${MK_NLS} != "no"
.for alias nls in ${NLS_ALIASES}
	${INSTALL_SYMLINK} -T "package=utilities" \
	    "${nls}" "${DESTDIR}${SHAREDIR}/nls/${alias}"
.endfor
.endif

.include <bsd.prog.mk>

.if ${MK_INSTALL_AS_USER} == "yes" && ${_uid} != 0
MTREE_FILTER= sed -e 's,\([gu]\)name=,\1id=,g' \
	-e 's,\(uid=\)[^ ]* ,\1${_uid} ,' \
	-e 's,\(gid=\)[^ ]* ,\1${_gid} ,' \
	-e 's,\(uid=\)[^ ]*$$,\1${_uid},' \
	-e 's,\(gid=\)[^ ]*$$,\1${_gid},'
.else
MTREE_FILTER= cat
.if !defined(NO_FSCHG)
MTREE_FSCHG=	-i
.endif
.endif

=== include/Makefile ===
#	@(#)Makefile	8.2 (Berkeley) 1/4/94
#
# Doing a "make install" builds /usr/include.

.include <src.opts.mk>

PACKAGE=clibs
CLEANFILES= osreldate.h version
SUBDIR= arpa protocols rpcsvc rpc xlocale
.if ${MACHINE_CPUARCH} == "amd64"
SUBDIR+=		i386
INCLUDE_SUBDIRS+=	i386
.endif
.if ${MACHINE_CPUARCH} == "aarch64"
SUBDIR+=		arm
INCLUDE_SUBDIRS+=	arm
.endif
SUBDIR_PARALLEL=
INCS=	a.out.h ar.h assert.h bitstring.h byteswap.h \
	complex.h cpio.h _ctype.h ctype.h \
	db.h \
	dirent.h dlfcn.h elf.h elf-hints.h endian.h err.h fmtmsg.h fnmatch.h \
	fstab.h fts.h ftw.h getopt.h glob.h grp.h \
	ieeefp.h ifaddrs.h \
	inttypes.h iso646.h kenv.h langinfo.h libgen.h limits.h link.h \
	locale.h malloc.h malloc_np.h memory.h monetary.h mpool.h mqueue.h \
	ndbm.h netconfig.h \
	netdb.h nl_types.h nlist.h nss.h nsswitch.h paths.h \
	printf.h proc_service.h pthread.h \
	pthread_np.h pwd.h ranlib.h readpassphrase.h regex.h \
	res_update.h resolv.h runetype.h sched.h \
	search.h semaphore.h setjmp.h \
	signal.h spawn.h stab.h stdalign.h stdbool.h stdckdint.h stddef.h \
	stdnoreturn.h stdio.h stdlib.h string.h stringlist.h \
	strings.h sysexits.h tar.h termios.h tgmath.h \
	time.h timeconv.h timers.h ttyent.h \
	uchar.h ulimit.h unistd.h utime.h utmpx.h uuid.h varargs.h \
	wchar.h wctype.h wordexp.h xlocale.h

.PATH: ${SRCTOP}/contrib/libc-vis
INCS+=	vis.h

MHDRS=	float.h floatingpoint.h

PHDRS=	_semaphore.h stdarg.h

LHDRS=	aio.h errno.h fcntl.h linker_set.h poll.h stdatomic.h stdint.h \
	syslog.h ucontext.h

LDIRS=	geom net net80211 netgraph netinet netinet6 \
	netipsec netlink netsmb nfs nfsclient nfsserver sys vm

LSUBDIRS=	dev/acpica dev/agp dev/ciss dev/filemon dev/firewire \
	dev/hwpmc dev/hyperv \
	dev/ic dev/iicbus dev/io dev/mfi dev/mmc \
	dev/ofw dev/pbio dev/pci ${_dev_powermac_nvram} dev/ppbus dev/pwm \
	dev/smbus dev/speaker dev/tcp_log dev/veriexec dev/vkbd dev/wg \
	fs/devfs fs/fdescfs fs/msdosfs fs/nfs fs/nullfs \
	fs/procfs fs/smbfs fs/udf fs/unionfs \
	geom/cache geom/concat geom/eli geom/gate geom/journal geom/label \
	geom/mirror geom/mountver geom/multipath geom/nop \
	geom/raid geom/raid3 geom/shsec geom/stripe geom/union geom/virstor \
	net/altq \
	net/route \
	netgraph/netflow \
	netinet/cc \
	netinet/netdump \
	netinet/tcp_stacks \
	netlink/route \
	security/mac_biba security/mac_bsdextended security/mac_lomac \
	security/mac_mls security/mac_partition \
	security/mac_veriexec \
	sys/disk \
	ufs/ffs ufs/ufs

LSUBSUBDIRS=	dev/mpt/mpilib

.PATH: ${SRCTOP}/sys/dev/acpica
ACPICA=		acpi_hpet.h \
		acpiio.h
ACPICADIR=	${INCLUDEDIR}/dev/acpica

.PATH: ${SRCTOP}/sys/dev/agp
AGP=		agpreg.h
AGPDIR=		${INCLUDEDIR}/dev/agp

.PATH: ${SRCTOP}/sys/bsm
BSM=		audit.h \
		audit_errno.h \
		audit_internal.h \
		audit_record.h \
		audit_domain.h \
		audit_fcntl.h \
		audit_kevents.h \
		audit_socket_type.h
BSMPACKAGE=	libbsm
BSMDIR=		${INCLUDEDIR}/bsm

.PATH: ${SRCTOP}/sys/security/audit
SECAUDIT=	audit.h \
		audit_ioctl.h \
		audit_private.h
SECAUDITPACKAGE=	libbsm
SECAUDITDIR=	${INCLUDEDIR}/security/audit

.PATH:	${SRCTOP}/sys/cam
CAM=	cam.h \
	cam_ccb.h \
	cam_compat.h \
	cam_debug.h \
	cam_iosched.h \
	cam_periph.h \
	cam_queue.h \
	cam_sim.h \
	cam_xpt.h \
	cam_xpt_internal.h \
	cam_xpt_periph.h \
	cam_xpt_sim.h
CAMDIR=	${INCLUDEDIR}/cam

.PATH: ${SRCTOP}/sys/cam/ata
CAMATA=		ata_all.h
CAMATADIR=	${INCLUDEDIR}/cam/ata

.PATH: ${SRCTOP}/sys/cam/mmc
CAMMMC=		mmc.h \
		mmc_bus.h \
		mmc_all.h
CAMMMCDIR=	${INCLUDEDIR}/cam/mmc

.PATH: ${SRCTOP}/sys/cam/nvme
CAMNVME=	nvme_all.h
CAMNVMEDIR=	${INCLUDEDIR}/cam/nvme

.PATH: ${SRCTOP}/sys/cam/scsi
CAMSCSI=	scsi_all.h \
		scsi_cd.h \
		scsi_ch.h \
		scsi_da.h \
		scsi_enc.h \
		scsi_enc_internal.h \
		scsi_iu.h \
		scsi_message.h \
		scsi_pass.h \
		scsi_pt.h \
		scsi_sa.h \
		scsi_ses.h \
		scsi_sg.h \
		scsi_targetio.h \
		smp_all.h
CAMSCSIDIR=	${INCLUDEDIR}/cam/scsi

.PATH: ${SRCTOP}/sys/fs/cd9660
FS9660=		cd9660_mount.h \
		cd9660_node.h \
		cd9660_rrip.h \
		iso.h \
		iso_rrip.h
FS9660DIR=	${INCLUDEDIR}/isofs/cd9660

.PATH: ${SRCTOP}/sys/dev/evdev
EVDEV=		input.h \
		input-event-codes.h \
		uinput.h
EVDEVDIR=	${INCLUDEDIR}/dev/evdev

.PATH: ${SRCTOP}/sys/dev/hid
HID=		hid.h \
		hidraw.h
HIDDIR=		${INCLUDEDIR}/dev/hid

.PATH: ${SRCTOP}/sys/dev/hyperv/include ${SRCTOP}/sys/dev/hyperv/utilities
HYPERV=		hv_snapshot.h \
		hyperv.h
HYPERVDIR=	${INCLUDEDIR}/dev/hyperv

.PATH: ${SRCTOP}/sys/opencrypto
OPENCRYPTO=	cryptodev.h
OPENCRYPTODIR=	${INCLUDEDIR}/crypto

.PATH: ${SRCTOP}/sys/dev/nvme
NVME=		nvme.h
NVMEDIR=	${INCLUDEDIR}/dev/nvme

.PATH: ${SRCTOP}/sys/dev/pci
PCI=		pcireg.h
PCIDIR=		${INCLUDEDIR}/dev/pci

.PATH: ${SRCTOP}/sys/dev/veriexec
VERIEXEC=	veriexec_ioctl.h
VERIEXECDIR=	${INCLUDEDIR}/dev/veriexec

.PATH: ${SRCTOP}/sys/netpfil/ipfilter/netinet
IPFILTER=	ip_auth.h \
		ip_compat.h \
		ip_dstlist.h \
		ip_fil.h \
		ip_frag.h \
		ip_htable.h \
		ip_lookup.h \
		ip_nat.h \
		ip_pool.h \
		ip_proxy.h \
		ip_rules.h \
		ip_scan.h \
		ip_state.h \
		ip_sync.h \
		ipf_rb.h \
		ipl.h \
		radix_ipf.h
IPFILTERDIR=	${INCLUDEDIR}/netinet

.PATH: ${SRCTOP}/sys/netpfil/pf
PF=		pf.h \
		pf_altq.h \
		pf_mtag.h
PFPACKAGE=	pf
PFDIR=	${INCLUDEDIR}/netpfil/pf

.PATH: ${SRCTOP}/sys/rpc
RPC=		rpcsec_tls.h \
		types.h
RPCDIR=		${INCLUDEDIR}/rpc

.PATH: ${SRCTOP}/sys/teken
TEKEN=		teken.h
TEKENDIR=	${INCLUDEDIR}/teken

.PATH: ${SRCTOP}/sys/contrib/openzfs/include/sys
NVPAIR=		nvpair.h
NVPAIRDIR=	${INCLUDEDIR}/sys

.PATH: ${SRCTOP}/sys/dev/mlx5
MLX5=		mlx5io.h
MLX5DIR=	${INCLUDEDIR}/dev/mlx5

.PATH: ${SRCTOP}/sys/dev/wg
WG=		if_wg.h
WGDIR=		${INCLUDEDIR}/dev/wg

INCSGROUPS=	INCS \
		ACPICA \
		AGP \
		BSM \
		CAM \
		CAMATA \
		CAMMMC \
		CAMNVME \
		CAMSCSI \
		CRYPTO \
		EVDEV \
		FS9660 \
		HID \
		HYPERV \
		OPENCRYPTO \
		NVME \
		PCI \
		RPC \
		SECAUDIT \
		TEKEN \
		VERIEXEC \
		WG

.if ${MK_IPFILTER} != "no"
INCSGROUPS+=	IPFILTER
.endif

.if ${MK_PF} != "no"
INCSGROUPS+=	PF
.endif

.if ${MK_CDDL} != "no"
INCSGROUPS+=	NVPAIR
.endif

.if ${MK_MLX5TOOL} != "no"
INCSGROUPS+=	MLX5
.endif

.if ${MK_BLUETOOTH} != "no"
LSUBSUBDIRS+=	netgraph/bluetooth/include
.endif

.if ${MK_CUSE} != "no"
LSUBDIRS+=	fs/cuse
.endif

.if ${MK_GSSAPI} != "no"
SUBDIR+=	gssapi
INCS+=		gssapi.h
.endif

.if ${MK_HESIOD} != "no"
INCS+=	hesiod.h
.endif

# Handle the #define aliases for libiconv
.if ${MK_ICONV} == "yes"
INCS+=		iconv.h
.endif

.if ${MK_USB} != "no"
LSUBDIRS+=	dev/usb
.endif

.if ${MACHINE_CPUARCH} == "powerpc" && ${MACHINE_ARCH} != "powerpcspe"
_dev_powermac_nvram=	dev/powermac_nvram
.endif

# Define SHARED to indicate whether you want symbolic links to the system
# source (``symlinks''), or a separate copy (``copies'').  ``symlinks'' is
# probably only useful for developers and should be avoided if you do not
# wish to tie your /usr/include and /usr/src together.
#SHARED=	symlinks
SHARED?=	copies

INCS+=	osreldate.h

SYSDIR=			${SRCTOP}/sys
NEWVERS_SH=		${SYSDIR}/conf/newvers.sh
PARAM_H=		${SYSDIR}/sys/param.h
MK_OSRELDATE_SH=	${.CURDIR}/mk-osreldate.sh

SYMLINKS+= ${LIBDIR:C,[^/]+,..,g:C,^/,,}${INCLUDEDIR} ${LIBDIR}/include

osreldate.h: ${NEWVERS_SH} ${PARAM_H} ${MK_OSRELDATE_SH}
	env NEWVERS_SH=${NEWVERS_SH} PARAMFILE=${PARAM_H} SYSDIR=${SYSDIR} \
	    sh ${MK_OSRELDATE_SH}

.for i in ${LHDRS}
INCSLINKS+=	sys/$i ${INCLUDEDIR}/$i
.endfor
.for i in ${MHDRS}
INCSLINKS+=	machine/$i ${INCLUDEDIR}/$i
.endfor
.for i in ${PHDRS}
INCSLINKS+=	sys/$i ${INCLUDEDIR}/$i
.endfor

.if ${MACHINE} != ${MACHINE_CPUARCH}
_MARCHS=	${MACHINE_CPUARCH}
.endif
.if ${MACHINE_CPUARCH} == "i386" || ${MACHINE_CPUARCH} == "amd64"
_MARCHS+=	x86
.endif

META_TARGETS+=	compat
stage_includes: ${SHARED}
SDESTDIR=	${SYSROOT:U${DESTDIR}}

# Take care of stale directory-level symlinks.
# Note: The "|| true" after find is needed in case one of the directories does
# not exist (yet).
compat:
	cd ${SDESTDIR}${INCLUDEDIR}; find ${LDIRS} ${LSUBDIRS} machine ${_MARCHS} \
	    crypto -maxdepth 0 -mindepth 0 -type l -print -delete || true
	mtree -deU ${NO_ROOT:D-W} ${MTREE_FOLLOWS_SYMLINKS} \
	    -f ${SRCTOP}/etc/mtree/BSD.include.dist \
	    -p ${SDESTDIR}${INCLUDEDIR} > /dev/null
.for d in ${INCLUDE_SUBDIRS}
	${INSTALL} -d ${TAG_ARGS} -o ${BINOWN} -g ${BINGRP} -m 755 \
	    ${SDESTDIR}${INCLUDEDIR}/${d}
.endfor

copies: .PHONY .META
	cd ${SDESTDIR}${INCLUDEDIR}; find ${LDIRS} ${LSUBDIRS} ${LSUBSUBDIRS} crypto \
	    machine machine/pc ${_MARCHS} -maxdepth 1 -mindepth 1 -type l \
	    -name "*.h" -print -delete || true
.for i in ${LDIRS} ${LSUBDIRS:Ndev/agp:Ndev/acpica:Ndev/evdev:Ndev/hid:Ndev/hyperv:Ndev/pci:Ndev/veriexec:Ndev/wg} ${LSUBSUBDIRS}
	cd ${SRCTOP}/sys; \
	${INSTALL} -C ${TAG_ARGS:D${TAG_ARGS},dev} -o ${BINOWN} -g ${BINGRP} -m 444 $i/*.h \
	    ${SDESTDIR}${INCLUDEDIR}/$i
.endfor
	cd ${SRCTOP}/sys/${MACHINE}/include; \
	${INSTALL} -C ${TAG_ARGS:D${TAG_ARGS},dev} -o ${BINOWN} -g ${BINGRP} -m 444 *.h \
	    ${SDESTDIR}${INCLUDEDIR}/machine
.if exists(${SRCTOP}/sys/${MACHINE}/include/pc)
	cd ${SRCTOP}/sys/${MACHINE}/include/pc; \
	${INSTALL} -C ${TAG_ARGS:D${TAG_ARGS},dev} -o ${BINOWN} -g ${BINGRP} -m 444 *.h \
	    ${SDESTDIR}${INCLUDEDIR}/machine/pc
.endif
.for _MARCH in ${_MARCHS}
.if exists(${SRCTOP}/sys/${_MARCH}/include)
	${INSTALL} -d ${TAG_ARGS:D${TAG_ARGS},dev} -o ${BINOWN} -g ${BINGRP} -m 755 \
	    ${SDESTDIR}${INCLUDEDIR}/${_MARCH}; \
	cd ${SRCTOP}/sys/${_MARCH}/include; \
	${INSTALL} -C ${TAG_ARGS:D${TAG_ARGS},dev} -o ${BINOWN} -g ${BINGRP} -m 444 *.h \
	    ${SDESTDIR}${INCLUDEDIR}/${_MARCH}
.if exists(${SRCTOP}/sys/${_MARCH}/include/pc)
	${INSTALL} -d ${TAG_ARGS:D${TAG_ARGS},dev} -o ${BINOWN} -g ${BINGRP} -m 755 \
	    ${SDESTDIR}${INCLUDEDIR}/${_MARCH}/pc; \
	cd ${SRCTOP}/sys/${_MARCH}/include/pc; \
	${INSTALL} -C ${TAG_ARGS:D${TAG_ARGS},dev} -o ${BINOWN} -g ${BINGRP} -m 444 *.h \
	    ${SDESTDIR}${INCLUDEDIR}/${_MARCH}/pc
.endif
.endif
.endfor

symlinks: .PHONY .META
	@${ECHO} "Setting up symlinks to kernel source tree..."
.for i in ${LDIRS}
	cd ${SRCTOP}; ${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} \
	    $$(printf '../../../%s ' sys/$i/*.h) ${SDESTDIR}${INCLUDEDIR}/$i
.endfor
.for i in ${LSUBDIRS:Ndev/agp:Ndev/acpica:Ndev/evdev:Ndev/hid:Ndev/hyperv:Ndev/pci:Ndev/veriexec:Ndev/wg}
	cd ${SRCTOP}; ${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} \
	    $$(printf '../../../../%s ' sys/$i/*.h) ${SDESTDIR}${INCLUDEDIR}/$i
.endfor
	${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} \
	    $$(printf '../../../../sys/dev/acpica/%s ' acpiio.h acpi_hpet.h) \
	    ${SDESTDIR}${INCLUDEDIR}/dev/acpica; \
	${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} ../../../../sys/dev/agp/agpreg.h \
	    ${SDESTDIR}${INCLUDEDIR}/dev/agp; \
	${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} \
	    $$(printf '../../../../sys/dev/evdev/%s ' input.h input-event-codes.h uinput.h) \
	    ${SDESTDIR}${INCLUDEDIR}/dev/evdev;
	${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} \
	    $$(printf '../../../../sys/dev/hid/%s ' hid.h hidraw.h) \
	    ${SDESTDIR}${INCLUDEDIR}/dev/hid; \
	${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} ../../../../sys/dev/hyperv/include/hyperv.h \
	    ${SDESTDIR}${INCLUDEDIR}/dev/hyperv; \
	${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} ../../../../sys/dev/hyperv/utilities/hv_snapshot.h \
	    ${SDESTDIR}${INCLUDEDIR}/dev/hyperv; \
	${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} ../../../../sys/dev/pci/pcireg.h \
	    ${SDESTDIR}${INCLUDEDIR}/dev/pci; \
	${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} ../../../../sys/dev/veriexec/veriexec_ioctl.h \
	    ${SDESTDIR}${INCLUDEDIR}/dev/veriexec;
.for i in ${LSUBSUBDIRS}
	cd ${SRCTOP}; ${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} \
	    $$(printf '../../../../../%s ' sys/$i/*.h) ${SDESTDIR}${INCLUDEDIR}/$i
.endfor
.if ${MK_IPFILTER} != "no"
	cd ${SRCTOP}; ${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} \
	    $$(printf '../../../%s ' sys/netpfil/ipfilter/netinet/*.h) \
	    ${SDESTDIR}${INCLUDEDIR}/netinet;
.endif
.if ${MK_PF} != "no"
	cd ${SRCTOP}; ${INSTALL_SYMLINK} ${TAG_ARGS:D${TAG_ARGS},dev} \

=== kerberos5/Makefile ===

SUBDIR=	lib .WAIT \
	libexec tools usr.bin usr.sbin
SUBDIR_PARALLEL=

# These are the programs which depend on Kerberos.
KPROGS=	lib/libpam \
	secure/lib/libssh secure/usr.bin/ssh secure/usr.sbin/sshd

# This target is used to rebuild these programs WITH Kerberos.
kerberize:
.for entry in ${KPROGS}
	cd ${.CURDIR:H}/${entry}; \
	${MAKE} cleandir; \
	${MAKE} obj; \
	${MAKE} all; \
	${MAKE} install
.endfor

# This target is used to rebuild these programs WITHOUT Kerberos.
dekerberize:
.for entry in ${KPROGS}
	cd ${.CURDIR:H}/${entry}; \
	${MAKE} MK_KERBEROS=no cleandir; \
	${MAKE} MK_KERBEROS=no obj; \
	${MAKE} MK_KERBEROS=no all; \
	${MAKE} MK_KERBEROS=no install
.endfor

.include <bsd.subdir.mk>

=== lib/Makefile ===
#	@(#)Makefile	8.1 (Berkeley) 6/4/93

.include <src.opts.mk>

# The SUBDIR_BOOTSTRAP list is a small set of libraries which are used by many
# of the other libraries.  These are built first with a .WAIT between them
# and the main list to avoid needing a SUBDIR_DEPEND line on every library
# naming just these few items.

SUBDIR_BOOTSTRAP= \
	csu \
	.WAIT \
	libc \
	libc_nonshared \
	libcompiler_rt \
	${_libclang_rt} \
	libc++ \
	libc++experimental \
	libcxxrt \
	libder \
	libelf \
	libssp \
	libssp_nonshared \
	msun

# The main list; please keep these sorted alphabetically.
# The only exception is sqlite3: we place it at the start of the list since it
# takes a long time to build and starting it first improves parallelism.

SUBDIR=	${SUBDIR_BOOTSTRAP} \
	.WAIT \
	libsqlite3 \
	geom \
	lib9p \
	libalias \
	libarchive \
	libauditd \
	libbegemot \
	libblocksruntime \
	libbsddialog \
	libbsdstat \
	libbsm \
	libbz2 \
	libcalendar \
	libcam \
	libcapsicum \
	libcasper \
	libcompat \
	libcrypt \
	libdevctl \
	libdevdctl \
	libdevinfo \
	libdevstat \
	libdl \
	libdwarf \
	libedit \
	libelftc \
	libevent1 \
	libexecinfo \
	libexpat \
	libfetch \
	libgcc_eh \
	libgcc_s \
	libgeom \
	libifconfig \
	libipsec \
	libiscsiutil \
	libjail \
	libkiconv \
	libkvm \
	liblua \
	liblzma \
	libmemstat \
	libmd \
	libmixer \
	libmt \
	lib80211 \
	libnetbsd \
	libnetmap \
	libnv \
	libopenbsd \
	libpam \
	libpathconv \
	libpcap \
	libpjdlog \
	libproc \
	libprocstat \
	libregex \
	librpcsvc \
	librss \
	librt \
	librtld_db \
	libsbuf \
	libsmb \
	libstdbuf \
	libstdthreads \
	libsysdecode \
	libtacplus \
	libthr \
	libthread_db \
	libucl \
	libufs \
	libugidfw \
	libulog \
	libutil \
	${_libvgl} \
	libwrap \
	libxo \
	liby \
	libyaml \
	libz \
	libzstd \
	ncurses \
	nss_tacplus

# Inter-library dependencies.  When the makefile for a library contains LDADD
# libraries, those libraries should be listed as build order dependencies here.

SUBDIR_DEPEND_geom=	libufs
SUBDIR_DEPEND_googletest= libregex
SUBDIR_DEPEND_libarchive= libz libbz2 libexpat liblzma libmd libzstd
SUBDIR_DEPEND_libauditdm= libbsm
SUBDIR_DEPEND_libbsddialog= ncurses
SUBDIR_DEPEND_libbsnmp= ${_libnetgraph}
SUBDIR_DEPEND_libc++:= libcxxrt
# libssp_nonshared doesn't need to be linked into libc on every arch, but it is
# small enough to build that this bit of serialization is likely insignificant.
SUBDIR_DEPEND_libc= libcompiler_rt libssp_nonshared
SUBDIR_DEPEND_libcam= libsbuf
SUBDIR_DEPEND_libcasper= libnv
SUBDIR_DEPEND_libdevstat= libkvm
SUBDIR_DEPEND_libdpv= libfigpar ncurses libutil
SUBDIR_DEPEND_libedit= ncurses
SUBDIR_DEPEND_libgeom= libexpat libsbuf
SUBDIR_DEPEND_librpcsec_gss= libgssapi
SUBDIR_DEPEND_libmagic= libz
SUBDIR_DEPEND_libmemstat= libkvm
SUBDIR_DEPEND_libpam= libcrypt ${_libradius} librpcsvc libtacplus libutil ${_libypclnt} ${_libcom_err}
SUBDIR_DEPEND_libpjdlog= libutil
SUBDIR_DEPEND_libprocstat= libkvm libutil
SUBDIR_DEPEND_libradius= libmd
SUBDIR_DEPEND_libsmb= libkiconv
SUBDIR_DEPEND_libtacplus= libmd
SUBDIR_DEPEND_libulog= libmd
SUBDIR_DEPEND_libunbound= ${_libldns}
SUBDIR_DEPEND_liblzma= libthr
.if ${MK_OFED} != "no"
SUBDIR_DEPEND_libpcap= ofed
.endif
SUBDIR_DEPEND_nss_tacplus= libtacplus

# NB: keep these sorted by MK_* knobs

SUBDIR.${MK_BEARSSL}+=	libbearssl libsecureboot
SUBDIR.${MK_BLACKLIST}+=libblacklist
SUBDIR.${MK_BLUETOOTH}+=libbluetooth libsdp
SUBDIR.${MK_BSNMP}+=	libbsnmp

.if !defined(COMPAT_LIBCOMPAT)
.if ${MK_CLANG} != "no" || ${MK_LLD} != "no" || \
    ${MK_LLDB} != "no" || ${MK_LLVM_BINUTILS} != "no"
SUBDIR+=	clang
.endif
.endif

SUBDIR.${MK_CUSE}+= 	libcuse
SUBDIR.${MK_TOOLCHAIN}+=libpe
SUBDIR.${MK_DIALOG}+=	libdpv libfigpar
SUBDIR.${MK_FDT}+=	libfdt
SUBDIR.${MK_FILE}+=	libmagic
SUBDIR.${MK_GPIO}+=	libgpio
SUBDIR.${MK_GSSAPI}+=	libgssapi librpcsec_gss
SUBDIR.${MK_ICONV}+=	libiconv_modules
SUBDIR.${MK_KERBEROS_SUPPORT}+=	libcom_err
SUBDIR.${MK_LDNS}+=	libldns
SUBDIR.${MK_STATS}+=	libstats

# The libraries under libclang_rt can only be built by clang.
.if (${COMPILER_TYPE} == "clang" || make(clean) || make(cleandir)) && \
    ${MK_CLANG} != "no"
_libclang_rt=	libclang_rt
.elif (${MK_ASAN} != "no" || ${MK_UBSAN} != "no") && make(all)
.error Requested build with sanitizers but cannot build runtime libraries!
.endif

SUBDIR.${MK_EFI}+=	libefivar
SUBDIR.${MK_GOOGLETEST}+=	googletest
SUBDIR.${MK_NETGRAPH}+=	libnetgraph
SUBDIR.${MK_NIS}+=	libypclnt

.if ${MACHINE_CPUARCH} == "i386" || ${MACHINE_CPUARCH} == "amd64"
_libvgl=	libvgl
.endif

.if ${MACHINE_CPUARCH} == "aarch64"
SUBDIR.${MK_PMC}+=	libopencsd
.endif

.if ${MACHINE_CPUARCH} == "amd64"
SUBDIR.${MK_PMC}+=	libipt
SUBDIR.${MK_BHYVE}+=	libvmmapi
.endif

.if ${MACHINE_ARCH} != "powerpc" && ${MACHINE_CPUARCH} != "arm"
SUBDIR.${MK_OPENMP}+=	libomp
.endif
.if ${MK_USB} != "no"
SUBDIR.${MK_OPENSSH}+=	libcbor libfido2
.endif
SUBDIR.${MK_OPENSSL}+=	libmp
SUBDIR.${MK_PF}+=	libpfctl
SUBDIR.${MK_PMC}+=	libpmc libpmcstat
SUBDIR.${MK_RADIUS_SUPPORT}+=	libradius
SUBDIR.${MK_SENDMAIL}+=	libmilter libsm libsmdb libsmutil
SUBDIR.${MK_TELNET}+=	libtelnet
SUBDIR.${MK_TESTS_SUPPORT}+=	atf
SUBDIR.${MK_TESTS_SUPPORT}+=	liblutok
SUBDIR.${MK_TESTS}+=	tests
SUBDIR.${MK_UNBOUND}+=	libunbound
SUBDIR.${MK_USB}+=	libusbhid libusb
SUBDIR.${MK_OFED}+=	ofed
SUBDIR.${MK_VERIEXEC}+=	libveriexec
SUBDIR.${MK_ZFS}+=	libbe

.if !make(install)
SUBDIR_PARALLEL=
.endif

.include <bsd.subdir.mk>

=== libexec/Makefile ===
#	@(#)Makefile	8.1 (Berkeley) 6/4/93

.include <src.opts.mk>

.include <bsd.compat.pre.mk>

SUBDIR=	${_atf} \
	${_atrun} \
	${_blacklistd-helper} \
	${_comsat} \
	${_dma} \
	flua \
	getty \
	${_hyperv} \
	kgdb \
	${_mail.local} \
	${_makewhatis.local} \
	${_mknetid} \
	${_phttpget} \
	${_pppoed} \
	rc \
	revnetgroup \
	${_rlogind} \
	rpc.rquotad \
	rpc.rstatd \
	rpc.rusersd \
	rpc.rwalld \
	rpc.sprayd \
	${_rshd} \
	${_rtld-elf} \
	save-entropy \
	${_nuageinit} \
	${_smrsh} \
	${_tests} \
	${_tftp-proxy} \
	ulog-helper \
	${_ypxfr}

.if ${MK_AT} != "no"
_atrun=		atrun
.endif

.if ${MK_BLACKLIST} != "no"
_blacklistd-helper+=	blacklistd-helper
.endif

.if ${MK_BOOTPD} != "no"
SUBDIR+=	bootpd
.endif

.if ${MK_FINGER} != "no"
SUBDIR+=	fingerd
.endif

.if ${MK_FREEBSD_UPDATE} != "no"
_phttpget=	phttpget
.endif

.if ${MK_FTP} != "no"
SUBDIR+=	ftpd
.endif

.if ${MK_MAIL} != "no"
_comsat=	comsat
.endif

.if ${MK_DMAGENT} != "no"
_dma=		dma
.endif

.if ${MK_HYPERV} != "no"
_hyperv+=	hyperv
.endif

.if ${MK_NIS} != "no"
_mknetid=	mknetid
_ypxfr=		ypxfr
.endif

.if ${MK_NETGRAPH} != "no"
_pppoed=	pppoed
.endif

.if ${MK_PF} != "no"
_tftp-proxy=	tftp-proxy
.endif

.if !defined(NO_PIC) && !defined(NO_RTLD)
_rtld-elf=	rtld-elf
.for LIBCOMPAT libcompat in ${_ALL_LIBCOMPATS_libcompats}
SUBDIR.${MK_LIB${LIBCOMPAT}}+=	rtld-elf${libcompat}
.endfor
.endif

.if ${MK_RBOOTD} != "no"
SUBDIR+=	rbootd
.endif

.if ${MK_SENDMAIL} != "no"
_mail.local=	mail.local
_smrsh=		smrsh
.endif

.if ${MK_MAN_UTILS} != "no"
_makewhatis.local=	makewhatis.local
.endif

.if ${MK_TALK} != "no"
SUBDIR+=	talkd
.endif

.if ${MK_TCP_WRAPPERS} != "no"
SUBDIR+=	tcpd
.endif

.if ${MK_TFTP} != "no"
SUBDIR+=	tftpd
.endif

.if ${MK_TESTS} != "no"
_tests=		tests
.endif

.if ${MK_TESTS_SUPPORT} != "no"
_atf=		atf
.endif

.if ${MK_NUAGEINIT} != "no"
_nuageinit=	nuageinit
.endif

.include <bsd.arch.inc.mk>

.include <bsd.subdir.mk>

=== release/Makefile ===
#
# Makefile for building releases and release media.
#
# User-driven targets:
#  cdrom: Builds release CD-ROM media (disc1.iso)
#  dvdrom: Builds release DVD-ROM media (dvd1.iso)
#  memstick: Builds memory stick image (memstick.img)
#  mini-memstick: Builds minimal memory stick image (mini-memstick.img)
#  ftp: Sets up FTP distribution area (ftp)
#  release: Invokes real-release, vm-release, cloudware-release and oci-release targets
#  real-release: Build all media and FTP distribution area
#  vm-release: Build all virtual machine image targets
#  cloudware-release: Build all cloud hosting provider targets
#  oci-release: Build all OCI container images
#  install: Invokes the release-install, vm-install and oci-install targets
#  release-install: Copies all release installation media into ${DESTDIR}
#  vm-install: Copies all virtual machine images into ${DESTDIR}
#  cloud-install: Copies non-uploaded cloud images into ${DESTDIR}
#  oci-install: Copies all OCI container images into ${DESTDIR}
#
# Variables affecting the build process:
#  WORLDDIR: location of src tree -- must have built world and default kernel
#            (by default, the directory above this one)
#  PORTSDIR: location of ports tree to distribute (default: /usr/ports)
#  XTRADIR:  xtra-bits-dir argument for <arch>/mkisoimages.sh
#  NOPKG:    if set, do not distribute third-party packages
#  NOPORTS:  if set, do not distribute ports tree
#  NOSRC:    if set, do not distribute source tree
#  WITH_DVD: if set, generate dvd1.iso
#  WITH_COMPRESSED_IMAGES: if set, compress installation images with xz(1)
#		(uncompressed images are not removed)
#  WITH_VMIMAGES: if set, build virtual machine images with the release
#  WITH_COMPRESSED_VMIMAGES: if set, compress virtual machine disk images
#  		with xz(1) (extremely time consuming)
#  WITH_CLOUDWARE: if set, build cloud hosting disk images with the release
#  TARGET/TARGET_ARCH: architecture of built release
#

WORLDDIR?=	${.CURDIR}/..
PORTSDIR?=	/usr/ports

.include "${WORLDDIR}/share/mk/bsd.compat.pre.mk"

.if !defined(TARGET) || empty(TARGET)
TARGET=		${MACHINE}
.endif
.if !defined(TARGET_ARCH) || empty(TARGET_ARCH)
.if ${TARGET} == ${MACHINE}
TARGET_ARCH=	${MACHINE_ARCH}
.else
TARGET_ARCH=	${TARGET}
.endif
.endif
IMAKE=		${MAKE} TARGET_ARCH=${TARGET_ARCH} TARGET=${TARGET}
DISTDIR=	dist

# Define OSRELEASE by using newvers.sh
.if !defined(OSRELEASE) || empty(OSRELEASE)
.for _V in TYPE BRANCH REVISION
${_V}!=	eval $$(awk '/^${_V}=/{print}' ${.CURDIR}/../sys/conf/newvers.sh); echo $$${_V}
.endfor
.for _V in ${TARGET_ARCH}
.if !empty(TARGET:M${_V})
OSRELEASE=	${TYPE}-${REVISION}-${BRANCH}-${TARGET}
VOLUME_LABEL=	${REVISION:C/[.-]/_/g}_${BRANCH:C/[.-]/_/g}_${TARGET}
.else
OSRELEASE=	${TYPE}-${REVISION}-${BRANCH}-${TARGET}-${TARGET_ARCH}
VOLUME_LABEL=	${REVISION:C/[.-]/_/g}_${BRANCH:C/[.-]/_/g}_${TARGET_ARCH}
.endif
.endfor
.endif

.if ${.MAKE.OS} == "FreeBSD"
# For installing packages into the release media.
.if defined(NO_ROOT)
PKG_ENV+=	INSTALL_AS_USER=yes
PKG_ARGS+=	-o METALOG=METALOG
.endif
PKG_ENV+=	ASSUME_ALWAYS_YES=yes
PKG_ARGS+=	-r ${.TARGET} -o REPOS_DIR=${.CURDIR}/pkg_repos
PKG_INSTALL=	env ${PKG_ENV} ${PKG_CMD} ${PKG_ARGS} install
.endif

.if !defined(VOLUME_LABEL) || empty(VOLUME_LABEL)
VOLUME_LABEL=	FreeBSD_Install
.endif

.if !exists(${PORTSDIR})
NOPORTS= true
.endif

DISTRIBUTIONS= base.txz kernel.txz
.if !defined(NOPORTS)
DISTRIBUTIONS+= ports.txz
.endif
.if !defined(NOSRC)
DISTRIBUTIONS+= src.txz
.endif

RELEASE_TARGETS= ftp
IMAGES=
.if exists(${.CURDIR}/${TARGET}/mkisoimages.sh)
RELEASE_TARGETS+= cdrom
IMAGES+=	disc1.iso bootonly.iso
. if defined(WITH_DVD) && !empty(WITH_DVD)
RELEASE_TARGETS+= dvdrom
IMAGES+=	dvd1.iso
. endif
.endif
.if exists(${.CURDIR}/${TARGET}/make-memstick.sh)
RELEASE_TARGETS+= memstick.img
RELEASE_TARGETS+= mini-memstick.img
IMAGES+=	memstick.img
IMAGES+=	mini-memstick.img
.endif

CLEANFILES=	packagesystem *.txz MANIFEST release ${IMAGES}
.if defined(WITH_COMPRESSED_IMAGES) && !empty(WITH_COMPRESSED_IMAGES)
. for I in ${IMAGES}
CLEANFILES+=	${I}.xz
. endfor
.endif
.if defined(WITH_DVD) && !empty(WITH_DVD)
CLEANFILES+=	pkg-stage
.endif
CLEANDIRS=	dist ftp disc1 disc1-disc1 disc1-memstick bootonly bootonly-bootonly bootonly-memstick dvd
beforeclean:
	chflags -R noschg .
.include <bsd.obj.mk>
clean: beforeclean

base.txz:
	mkdir -p ${DISTDIR}
	( cd ${WORLDDIR} && ${IMAKE} distributeworld DISTDIR=${.OBJDIR}/${DISTDIR} )
# TODO: Add NO_ROOT mode to mm-tree.sh
.if !defined(NO_ROOT)
# Set up mergemaster root database
	sh ${.CURDIR}/scripts/mm-mtree.sh -m ${WORLDDIR} -F \
	    "TARGET_ARCH=${TARGET_ARCH} TARGET=${TARGET} ${.MAKE.JOBS:D-j${.MAKE.JOBS}}" \
	    -D "${.OBJDIR}/${DISTDIR}/base"
.endif
	sh ${WORLDDIR}/usr.sbin/etcupdate/etcupdate.sh extract -B \
	    -m "${MAKE}" -M "TARGET_ARCH=${TARGET_ARCH} TARGET=${TARGET}" \
	    -s ${WORLDDIR} -d "${.OBJDIR}/${DISTDIR}/base/var/db/etcupdate" \
	    -L /dev/stdout ${NO_ROOT:D-N}
.if defined(NO_ROOT)
	echo "./var/db/etcupdate type=dir uname=root gname=wheel mode=0755" >> ${.OBJDIR}/${DISTDIR}/base.meta
	sed -n 's,^\.,./var/db/etcupdate/current,p' ${.OBJDIR}/${DISTDIR}/base/var/db/etcupdate/current/METALOG \
	    >> ${.OBJDIR}/${DISTDIR}/base.meta
	rm ${.OBJDIR}/${DISTDIR}/base/var/db/etcupdate/current/METALOG
.endif
# Package all components
	( cd ${WORLDDIR} && ${IMAKE} packageworld DISTDIR=${.OBJDIR}/${DISTDIR} )
	mv ${DISTDIR}/*.txz .

kernel.txz:
	mkdir -p ${DISTDIR}
	( cd ${WORLDDIR} && ${IMAKE} distributekernel DISTDIR=${.OBJDIR}/${DISTDIR} )
	( cd ${WORLDDIR} && ${IMAKE} packagekernel DISTDIR=${.OBJDIR}/${DISTDIR} )
	mv ${DISTDIR}/kernel*.txz .

src.txz:
	mkdir -p ${DISTDIR}/usr
	ln -fs ${WORLDDIR} ${DISTDIR}/usr/src
	( cd ${DISTDIR} && ${TAR_CMD} cLvf - --exclude .svn --exclude .zfs \
	    --exclude .git --exclude @ --exclude usr/src/release/dist usr/src | \
	    ${XZ_CMD} > ${.OBJDIR}/src.txz )

ports.txz:
	mkdir -p ${DISTDIR}/usr
	ln -fs ${PORTSDIR} ${DISTDIR}/usr/ports
	( cd ${DISTDIR} && ${TAR_CMD} cLvf - \
	    --exclude .git --exclude .svn \
	    --exclude usr/ports/distfiles --exclude usr/ports/packages \
	    --exclude 'usr/ports/INDEX*' --exclude work usr/ports | \
	    ${XZ_CMD} > ${.OBJDIR}/ports.txz )

disc1: packagesystem
# Install system
	mkdir -p ${.TARGET}
	( cd ${WORLDDIR} && ${IMAKE} installworld installkernel distribution \
	    DESTDIR=${.OBJDIR}/${.TARGET} MK_AT=no \
	    MK_INSTALLLIB=no MK_MAIL=no \
	    ${_ALL_LIBCOMPATS:@v@MK_LIB$v=no@} \
	    MK_TOOLCHAIN=no MK_PROFILE=no \
	    MK_RESCUE=no MK_DICT=no \
	    MK_KERNEL_SYMBOLS=no MK_TESTS=no MK_DEBUG_FILES=no \
	    -DDB_FROM_SRC )
# Copy distfiles
	mkdir -p ${.TARGET}/usr/freebsd-dist
	for dist in MANIFEST $$(ls *.txz | grep -v container | grep -vE -- '(${base ${_ALL_libcompats}:L:ts|})-dbg'); \
	    do cp $${dist} ${.TARGET}/usr/freebsd-dist; \
	done
.if defined(NO_ROOT)
	echo "./usr/freebsd-dist type=dir uname=root gname=wheel mode=0755" >> ${.TARGET}/METALOG
	for dist in MANIFEST $$(ls *.txz | grep -v container | grep -vE -- '(${base ${_ALL_libcompats}:L:ts|})-dbg'); \
	    do echo "./usr/freebsd-dist/$${dist} type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG; \
	done
.endif
.if ${.MAKE.OS} == "FreeBSD" && (!defined(NOPKG) || empty(NOPKG))
# Install packages onto release media.
	${PKG_INSTALL} wifi-firmware-kmod-release || true
.endif
# Set up installation environment
	ln -fs /tmp/bsdinstall_etc/resolv.conf ${.TARGET}/etc/resolv.conf
	echo sendmail_enable=\"NONE\" > ${.TARGET}/etc/rc.conf
	echo hostid_enable=\"NO\" >> ${.TARGET}/etc/rc.conf
	echo vfs.mountroot.timeout=\"10\" >> ${.TARGET}/boot/loader.conf
	echo kernels_autodetect=\"NO\" >> ${.TARGET}/boot/loader.conf
	echo loader_menu_multi_user_prompt=\"Installer\" >> ${.TARGET}/boot/loader.conf
	cp ${.CURDIR}/rc.local ${.TARGET}/etc
.if defined(NO_ROOT)
	echo "./etc/resolv.conf type=link uname=root gname=wheel mode=0644 link=/tmp/bsdinstall_etc/resolv.conf" >> ${.TARGET}/METALOG
	echo "./etc/rc.conf type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG
	echo "./etc/sysctl.conf type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG
	echo "./boot/loader.conf type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG
	echo "./etc/rc.local type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG
.endif
	touch ${.TARGET}

bootonly: packagesystem
# Install system
	mkdir -p ${.TARGET}
	( cd ${WORLDDIR} && ${IMAKE} installworld installkernel distribution \
	    DESTDIR=${.OBJDIR}/${.TARGET} MK_AT=no \
	    MK_GAMES=no \
	    MK_INSTALLLIB=no MK_MAIL=no \
	    ${_ALL_LIBCOMPATS:@v@MK_LIB$v=no@} \
	    MK_TOOLCHAIN=no MK_PROFILE=no \
	    MK_RESCUE=no MK_DICT=no \
	    MK_KERNEL_SYMBOLS=no MK_TESTS=no MK_DEBUG_FILES=no \
	    -DDB_FROM_SRC )
# Copy manifest only (no distfiles) to get checksums
	mkdir -p ${.TARGET}/usr/freebsd-dist
	cp MANIFEST ${.TARGET}/usr/freebsd-dist
.if defined(NO_ROOT)
	echo "./usr/freebsd-dist type=dir uname=root gname=wheel mode=0755" >> ${.TARGET}/METALOG
	echo "./usr/freebsd-dist/MANIFEST type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG
.endif
.if ${.MAKE.OS} == "FreeBSD" && (!defined(NOPKG) || empty(NOPKG))
# Install packages onto release media.
	${PKG_INSTALL} wifi-firmware-iwlwifi-kmod wifi-firmware-rtw88-kmod || true
.endif
# Set up installation environment
	ln -fs /tmp/bsdinstall_etc/resolv.conf ${.TARGET}/etc/resolv.conf
	echo sendmail_enable=\"NONE\" > ${.TARGET}/etc/rc.conf
	echo hostid_enable=\"NO\" >> ${.TARGET}/etc/rc.conf
	echo vfs.mountroot.timeout=\"10\" >> ${.TARGET}/boot/loader.conf
	echo kernels_autodetect=\"NO\" >> ${.TARGET}/boot/loader.conf
	echo loader_menu_multi_user_prompt=\"Installer\" >> ${.TARGET}/boot/loader.conf
	cp ${.CURDIR}/rc.local ${.TARGET}/etc
.if defined(NO_ROOT)
	echo "./etc/resolv.conf type=link uname=root gname=wheel mode=0644 link=/tmp/bsdinstall_etc/resolv.conf" >> ${.TARGET}/METALOG
	echo "./etc/rc.conf type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG
	echo "./etc/sysctl.conf type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG
	echo "./boot/loader.conf type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG
	echo "./etc/rc.local type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG
.endif

dvd: packagesystem
# Install system
	mkdir -p ${.TARGET}
	( cd ${WORLDDIR} && ${IMAKE} installworld installkernel distribution \
		DESTDIR=${.OBJDIR}/${.TARGET} MK_RESCUE=no MK_KERNEL_SYMBOLS=no \
		MK_TESTS=no MK_DEBUG_FILES=no \
		-DDB_FROM_SRC )
# Copy distfiles
	mkdir -p ${.TARGET}/usr/freebsd-dist
	for dist in MANIFEST $$(ls *.txz | grep -v container); \
	    do cp $${dist} ${.TARGET}/usr/freebsd-dist; \
	done
.if defined(NO_ROOT)
	echo "./usr/freebsd-dist type=dir uname=root gname=wheel mode=0755" >> ${.TARGET}/METALOG
	for dist in MANIFEST $$(ls *.txz | grep -v container); \
	    do echo "./usr/freebsd-dist/$${dist} type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG; \
	done
.endif
.if ${.MAKE.OS} == "FreeBSD" && (!defined(NOPKG) || empty(NOPKG))
# Install packages onto release media.
	${PKG_INSTALL} wifi-firmware-kmod-release || true
.endif
# Set up installation environment
	ln -fs /tmp/bsdinstall_etc/resolv.conf ${.TARGET}/etc/resolv.conf
	echo sendmail_enable=\"NONE\" > ${.TARGET}/etc/rc.conf
	echo hostid_enable=\"NO\" >> ${.TARGET}/etc/rc.conf
	echo vfs.mountroot.timeout=\"10\" >> ${.TARGET}/boot/loader.conf
	echo kernels_autodetect=\"NO\" >> ${.TARGET}/boot/loader.conf
	echo loader_menu_multi_user_prompt=\"Installer\" >> ${.TARGET}/boot/loader.conf
	cp ${.CURDIR}/rc.local ${.TARGET}/etc
.if defined(NO_ROOT)
	echo "./etc/resolv.conf type=link uname=root gname=wheel mode=0644 link=/tmp/bsdinstall_etc/resolv.conf" >> ${.TARGET}/METALOG
	echo "./etc/rc.conf type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG
	echo "./etc/sysctl.conf type=file uname=root gname=wheel mode=0644" >> ${.TARGET}/METALOG

=== sbin/Makefile ===
#	@(#)Makefile	8.5 (Berkeley) 3/31/94

.include <src.opts.mk>

SUBDIR=adjkerntz \
	camcontrol \
	clri \
	comcontrol \
	conscontrol \
	ddb \
	devd \
	devfs \
	devmatch \
	dhclient \
	dmesg \
	dump \
	dumpfs \
	dumpon \
	etherswitchcfg \
	ffsinfo \
	fsck \
	fsck_ffs \
	fsck_msdosfs \
	fsdb \
	fsirand \
	gbde \
	geom \
	ggate \
	growfs \
	gvinum \
	ifconfig \
	init \
	kldconfig \
	kldload \
	kldstat \
	kldunload \
	ldconfig \
	md5 \
	mdconfig \
	mdmfs \
	mknod \
	mksnap_ffs \
	mount \
	mount_cd9660 \
	mount_fusefs \
	mount_msdosfs \
	mount_nfs \
	mount_nullfs \
	mount_udf \
	mount_unionfs \
	newfs \
	newfs_msdos \
	nfsiod \
	nos-tun \
	nvmecontrol \
	pfilctl \
	rcorder \
	reboot \
	recoverdisk \
	resolvconf \
	restore \
	route \
	savecore \
	setkey \
	shutdown \
	swapon \
	sysctl \
	tunefs \
	umount

.if ${MK_INET} != "no" || ${MK_INET6} != "no"
SUBDIR+=	ping
.endif

SUBDIR.${MK_CCD}+=	ccdconfig
SUBDIR.${MK_HAST}+=	hastctl
SUBDIR.${MK_HAST}+=	hastd
SUBDIR.${MK_INET6}+=	rtsol
SUBDIR.${MK_IPFILTER}+=	ipf
SUBDIR.${MK_IPFW}+=	ipfw
SUBDIR.${MK_IPFW}+=	natd
SUBDIR.${MK_OPENSSL}+=	decryptcore
SUBDIR.${MK_PF}+=	pfctl
SUBDIR.${MK_PF}+=	pflogd
SUBDIR.${MK_QUOTAS}+=	quotacheck
SUBDIR.${MK_ROUTED}+=	routed
SUBDIR.${MK_VERIEXEC}+=	veriexec
SUBDIR.${MK_ZFS}+=	bectl
SUBDIR.${MK_ZFS}+=	zfsbootcfg

SUBDIR.${MK_TESTS}+=	tests

.include <bsd.arch.inc.mk>

SUBDIR_PARALLEL=

.include <bsd.prog.mk>

.include <bsd.subdir.mk>

=== share/Makefile ===
#	@(#)Makefile	8.1 (Berkeley) 6/5/93

.include <src.opts.mk>

# Do not include `info' in the SUBDIR list, it is handled separately.

SUBDIR=	${_colldef} \
	ctypedef \
	${_dict} \
	${_doc} \
	${_dtrace} \
	${_examples} \
	${_i18n} \
	keys \
	${_man} \
	${_me} \
	misc \
	${_mk} \
	${_monetdef} \
	${_msgdef} \
	${_numericdef} \
	${_sendmail} \
	skel \
	${_snmp} \
	${_syscons} \
	tabset \
	termcap \
	${_timedef} \
	${_vt} \
	${_zoneinfo}

# NB: keep these sorted by MK_* knobs

.if ${MK_BSNMP} != "no"
_snmp=		snmp
.endif

.if ${MK_CDDL} != "no"
_dtrace=	dtrace
.endif

.if ${MK_DICT} != "no"
_dict=		dict
.endif

.if ${MK_EXAMPLES} != "no"
_examples=	examples
.endif

.if ${MK_ICONV} != "no"
_i18n=		i18n
.endif

.if ${MK_LOCALES} != "no"
_colldef=	colldef colldef_unicode
_monetdef=	monetdef monetdef_unicode
_msgdef=	msgdef msgdef_unicode
_numericdef=	numericdef numericdef_unicode
_timedef=	timedef
.endif

.if ${MK_MAKE} != "no"
_mk=		mk
.endif

.if ${MK_MAN} != "no"
_man=		man
.endif

.if ${MK_SENDMAIL} != "no"
_sendmail=	 sendmail
.endif

.if ${MK_SHAREDOCS} != "no"
_doc=		doc
.endif

.if ${MK_SYSCONS} != "no"
_syscons=	syscons
.endif

SUBDIR.${MK_TESTS}+= tests

.if ${MK_VT} != "no"
_vt=		vt
.endif

.if ${MK_ZONEINFO} != "no"
_zoneinfo=	zoneinfo
.endif

SUBDIR_PARALLEL=

.include <bsd.subdir.mk>

=== stand/Makefile ===

.include <src.opts.mk>

# For amd64 we have to build 32 and 64 bit versions of things. For
# others we don't. LIB32LIST is a list of libraries, which if
# included, need to be built 32-bit as well.
.if ${MACHINE_ARCH} == "amd64"
LIB32LIST=libsa
.if ${MK_FORTH} != "no"
LIB32LIST+=		ficl
.endif
.if ${MK_LOADER_LUA} != "no"
LIB32LIST+=		liblua
.endif
.endif

S.yes+=			libsa

S.${MK_LOADER_OFW}+=	libofw
S.${MK_FDT}+=		fdt

S.${MK_FORTH}+=		ficl
S.${MK_FORTH}+=		forth
S.${MK_LOADER_LUA}+=	liblua
S.${MK_LOADER_LUA}+=	lua
S.yes+=			defaults
S.yes+=			fonts
S.yes+=			images
S.yes+=			man

.if ${MK_FORTH} != "no"
INTERP_DEPENDS+=	forth
.endif
.if ${MK_LOADER_LUA} != "no"
INTERP_DEPENDS+=	lua
.endif

.include <bsd.arch.inc.mk>

S.${MK_EFI}+=		efi
.if ${MK_FDT} != "no"
S.${MK_LOADER_KBOOT}+=	kboot
.endif
S.${MK_LOADER_UBOOT}+=	uboot

.if defined(LIB32LIST)
LIB32DEPENDS=	${LIB32LIST:S/$/32/}
.endif

.if exists(${.CURDIR}/${MACHINE}/.)
S.yes+=         ${MACHINE}
SUBDIR_DEPEND_${MACHINE}+=	${INTERP_DEPENDS}
.if ${MK_FDT} != "no"
SUBDIR_DEPEND_${MACHINE}+=	fdt
.endif
.if ${MK_LOADER_UBOOT} != "no"
SUBDIR_DEPEND_${MACHINE}+=	uboot
.endif
.if ${MK_LOADER_OFW} != "no"
SUBDIR_DEPEND_${MACHINE}+=	libofw
.endif
.endif

# Build the actual subdir list from S.yes, adding in the 32-bit
# variant if necessary.
.for _x in ${S.yes}
SUBDIR+=${_x}
.if defined(LIB32LIST) && ${LIB32LIST:M${_x}}
SUBDIR+=${_x}32
INTERP_DEPENDS+=${_x}32
.endif
.if ${_x} != "libsa"
SUBDIR_DEPEND_${_x}+=	libsa
SUBDIR_DEPEND_${_x}32+=	libsa32
.endif
.endfor

# Remaining dependencies
SUBDIR_DEPEND_forth+=	ficl
SUBDIR_DEPEND_lua+=	liblua

SUBDIR_DEPEND_efi+=	${INTERP_DEPENDS}
SUBDIR_DEPEND_kboot+=	${INTERP_DEPENDS}
.if ${MK_FDT} != "no"
SUBDIR_DEPEND_efi+=	fdt
SUBDIR_DEPEND_kboot+=	fdt
.endif

SUBDIR_DEPEND_uboot+=	${INTERP_DEPENDS}
.if ${MK_FDT} != "no"
SUBDIR_DEPEND_uboot+=	fdt
.endif

SUBDIR_PARALLEL=	yes

.include <bsd.subdir.mk>

# Simplified way to build-test the most important build combinations for the
# loader.
universe:
	sh ${SRCTOP}/tools/boot/universe.sh

=== sys/Makefile ===

# Directories to include in cscope name file and TAGS.
CSCOPEDIRS=	bsm cam cddl compat conf contrib crypto ddb dev fs gdb \
		geom gnu isa kern libkern modules net net80211 \
		netgraph netinet netinet6 netipsec netpfil \
		netsmb nfs nfsclient nfsserver nlm ofed opencrypto \
		rpc security sys ufs vm xdr xen ${CSCOPE_ARCHDIR}
.if !defined(CSCOPE_ARCHDIR)
.if defined(ALL_ARCH)
CSCOPE_ARCHDIR = amd64 arm arm64 i386 powerpc riscv x86
.else
CSCOPE_ARCHDIR = ${MACHINE}
.if ${MACHINE_CPUARCH} == "i386" || ${MACHINE_CPUARCH} == "amd64"
CSCOPE_ARCHDIR += x86
.endif
.endif
.endif

HTAGSFLAGS+= -at `awk -F= '/^RELEASE *=/{release=$2}; END {print "FreeBSD", release, "kernel"}' < conf/newvers.sh`

# You need the devel/cscope port for this.
cscope: cscope.out
cscope.out: ${.CURDIR}/cscope.files
	cd ${.CURDIR}; cscope -k -buq -p4 -v

${.CURDIR}/cscope.files: .PHONY
	cd ${.CURDIR}; \
		find ${CSCOPEDIRS} -name "*.[chSsly]" -a -type f > ${.TARGET}

cscope-clean:
	cd ${.CURDIR}; \
	    rm -f cscope.files cscope.out cscope.in.out cscope.po.out

#
# Installs SCM hooks to update the cscope database every time the source tree
# is updated.
# cscope understands incremental updates, so it's considerably faster when only
# a few files have changed.
#
HG_DIR=${.CURDIR}/../.hg
HG_HOOK=if [ \$$HG_ERROR -eq 0 ]; then cd sys && make -m ../share/mk cscope; fi
cscope-hook:
	@if [ -d ${HG_DIR} ]; then 					\
		if [ "`grep hooks ${HG_DIR}/hgrc`" = "" ]; then		\
			echo "[hooks]" >> ${HG_DIR}/hgrc;		\
			echo "update = ${HG_HOOK}" >> ${HG_DIR}/hgrc;	\
			echo "Hook installed in ${HG_DIR}/hgrc";	\
		else 							\
			echo "Mercurial update hook already exists.";	\
		fi;							\
	fi

# You need the devel/global and one of editor/emacs* ports for that.
TAGS ${.CURDIR}/TAGS: ${.CURDIR}/cscope.files
	rm -f ${.CURDIR}/TAGS
	cd ${.CURDIR}; xargs etags -a < ${.CURDIR}/cscope.files

.if !(make(cscope) || make(cscope-clean) || make(cscope-hook) || make(TAGS))
.include <src.opts.mk>

# Loadable kernel modules

.if defined(MODULES_WITH_WORLD)
SUBDIR+=modules
.endif

.include <bsd.subdir.mk>
.endif

=== contrib/byacc/package/debian/changelog ===
byacc (1:2.0.20230201) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Wed, 01 Feb 2023 19:12:06 -0500

byacc (1:2.0.20221229) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Thu, 29 Dec 2022 05:23:05 -0500

byacc (1:2.0.20221106) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 06 Nov 2022 10:51:43 -0500

byacc (1:2.0.20220128) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 28 Jan 2022 08:38:52 -0500

byacc (1:2.0.20220114) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 14 Jan 2022 16:33:35 -0500

byacc (1:2.0.20220109) unstable; urgency=low

  * maintenance updates, modify packaging to more closely match distributors.
    In particular, correct versioning using an epoch.

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 09 Jan 2022 10:49:20 -0500

byacc (20220102) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 02 Jan 2022 11:12:56 -0500

byacc (20220101) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 01 Jan 2022 07:06:35 -0500

byacc (20211224) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 24 Dec 2021 19:13:22 -0500

byacc (20210808) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 08 Aug 2021 15:26:10 -0400

byacc (20210802) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Mon, 02 Aug 2021 16:50:01 -0400

byacc (20210801) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 01 Aug 2021 15:30:22 -0400

byacc (20210619) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 19 Jun 2021 14:06:48 -0400

byacc (20210520) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Thu, 20 May 2021 15:25:00 -0400

byacc (20210328) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 28 Mar 2021 11:14:10 -0400

byacc (20210109) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 09 Jan 2021 09:32:51 -0500

byacc (20200910) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Thu, 10 Sep 2020 10:45:10 -0400

byacc (20200330) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Mon, 30 Mar 2020 19:31:42 -0400

byacc (20191125) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Mon, 25 Nov 2019 18:13:14 -0500

byacc (20191119) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Tue, 19 Nov 2019 20:40:56 -0500

byacc (20191103) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 03 Nov 2019 16:42:41 -0500

byacc (20190617) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 16 Jun 2019 15:51:03 -0400

byacc (20190616) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 16 Jun 2019 08:55:03 -0400

byacc (20180609) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 09 Jun 2018 20:42:16 -0400

byacc (20180525) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Mon, 21 May 2018 18:50:44 -0400

byacc (20180510) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Thu, 10 May 2018 04:59:09 -0400

byacc (20180509) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Wed, 09 May 2018 21:13:51 -0400

byacc (20180508) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Tue, 08 May 2018 16:24:39 -0400

byacc (20170709) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 09 Jul 2017 13:49:13 -0400

byacc (20170430) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 30 Apr 2017 16:55:15 -0400

byacc (20170201) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Wed, 01 Feb 2017 04:55:04 -0500

byacc (20161202) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 02 Dec 2016 07:58:46 -0500

byacc (20160606) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Mon, 06 Jun 2016 20:44:26 -0400

byacc (20160601) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Mon, 06 Jun 2016 05:21:18 -0400

byacc (20160324) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Thu, 24 Mar 2016 19:55:52 -0400

byacc (20150711) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 10 Jul 2015 20:53:15 -0400

byacc (20150705) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 05 Jul 2015 18:24:51 -0400

byacc (20141128) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 28 Nov 2014 10:42:17 -0500

byacc (20141006) unstable; urgency=low

  * maintenance updates

 -- Thomas E. Dickey <dickey@invisible-island.net>  Mon, 06 Oct 2014 18:52:03 -0400



=== sys/contrib/openzfs/contrib/debian/control ===
Source: openzfs-linux
Section: contrib/kernel
Priority: optional
Maintainer: ZFS on Linux specific mailing list <zfs-discuss@list.zfsonlinux.org>
Build-Depends: debhelper-compat (= 12),
               dh-python,
               dh-sequence-dkms | dkms (>> 2.1.1.2-5),
               libaio-dev,
               libblkid-dev,
               libcurl4-openssl-dev,
               libelf-dev,
               libpam0g-dev,
               libssl-dev | libssl1.0-dev,
               libtirpc-dev,
               libtool,
               libudev-dev,
               lsb-release,
               po-debconf,
               python3-all-dev,
               python3-cffi,
               python3-setuptools,
               python3-sphinx,
               uuid-dev,
               zlib1g-dev
Standards-Version: 4.5.1
Homepage: https://openzfs.org/
Vcs-Git: https://github.com/openzfs/zfs.git
Vcs-Browser: https://github.com/openzfs/zfs
Rules-Requires-Root: no
XS-Autobuild: yes

Package: openzfs-libnvpair3
Section: contrib/libs
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libnvpair1, libnvpair3
Replaces: libnvpair1, libnvpair3, libnvpair3linux
Conflicts: libnvpair3linux
Description: Solaris name-value library for Linux
 This library provides routines for packing and unpacking nv pairs for
 transporting data across process boundaries, transporting between
 kernel and userland, and possibly saving onto disk files.

Package: openzfs-libpam-zfs
Section: contrib/admin
Architecture: linux-any
Depends: libpam-runtime, ${misc:Depends}, ${shlibs:Depends}
Replaces: libpam-zfs
Conflicts: libpam-zfs
Description: PAM module for managing encryption keys for ZFS
 OpenZFS is a storage platform that encompasses the functionality of
 traditional filesystems and volume managers. It supports data checksums,
 compression, encryption, snapshots, and more.
 .
 This provides a Pluggable Authentication Module (PAM) that automatically
 unlocks encrypted ZFS datasets upon login.

Package: openzfs-libuutil3
Section: contrib/libs
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libuutil1, libuutil3
Replaces: libuutil1, libuutil3, libuutil3linux
Conflicts: libuutil3linux
Description: Solaris userland utility library for Linux
 This library provides a variety of glue functions for ZFS on Linux:
  * libspl: The Solaris Porting Layer userland library, which provides APIs
    that make it possible to run Solaris user code in a Linux environment
    with relatively minimal modification.
  * libavl: The Adelson-Velskii Landis balanced binary tree manipulation
    library.
  * libefi: The Extensible Firmware Interface library for GUID disk
    partitioning.
  * libshare: NFS, SMB, and iSCSI service integration for ZFS.

Package: openzfs-libzfs-dev
Section: contrib/libdevel
Architecture: linux-any
Depends: libssl-dev | libssl1.0-dev,
         openzfs-libnvpair3 (= ${binary:Version}),
         openzfs-libuutil3 (= ${binary:Version}),
         openzfs-libzfs4 (= ${binary:Version}),
         openzfs-libzfsbootenv1 (= ${binary:Version}),
         openzfs-libzpool5 (= ${binary:Version}),
         ${misc:Depends}
Replaces: libzfslinux-dev
Conflicts: libzfslinux-dev
Provides: libnvpair-dev, libuutil-dev
Description: OpenZFS filesystem development files for Linux
 Header files and static libraries for compiling software against
 libraries of OpenZFS filesystem.
 .
 This package includes the development files of libnvpair3, libuutil3,
 libzpool5 and libzfs4.

Package: openzfs-libzfs4
Section: contrib/libs
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
# The libcurl4 is loaded through dlopen("libcurl.so.4").
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=988521
Recommends: libcurl4
Breaks: libzfs2, libzfs4
Replaces: libzfs2, libzfs4, libzfs4linux
Conflicts: libzfs4linux
Description: OpenZFS filesystem library for Linux - general support
 OpenZFS is a storage platform that encompasses the functionality of
 traditional filesystems and volume managers. It supports data checksums,
 compression, encryption, snapshots, and more.
 .
 The OpenZFS library provides support for managing OpenZFS filesystems.

Package: openzfs-libzfsbootenv1
Section: contrib/libs
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libzfs2, libzfs4
Replaces: libzfs2, libzfs4, libzfsbootenv1linux
Conflicts: libzfsbootenv1linux
Description: OpenZFS filesystem library for Linux - label info support
 OpenZFS is a storage platform that encompasses the functionality of
 traditional filesystems and volume managers. It supports data checksums,
 compression, encryption, snapshots, and more.
 .
 The zfsbootenv library provides support for modifying ZFS label information.

Package: openzfs-libzpool5
Section: contrib/libs
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libzpool2, libzpool5
Replaces: libzpool2, libzpool5, libzpool5linux
Conflicts: libzpool5linux
Description: OpenZFS pool library for Linux
 OpenZFS is a storage platform that encompasses the functionality of
 traditional filesystems and volume managers. It supports data checksums,
 compression, encryption, snapshots, and more.
 .
 This zpool library provides support for managing zpools.

Package: openzfs-python3-pyzfs
Section: contrib/python
Architecture: linux-any
Depends: python3-cffi,
         openzfs-zfsutils (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends}
Replaces: python3-pyzfs
Conflicts: python3-pyzfs
Description: wrapper for libzfs_core C library
 libzfs_core is intended to be a stable interface for programmatic
 administration of ZFS. This wrapper provides one-to-one wrappers for
 libzfs_core API functions, but the signatures and types are more natural to
 Python.
 .
 nvlists are wrapped as dictionaries or lists depending on their usage.
 Some parameters have default values depending on typical use for
 increased convenience. Enumerations and bit flags become strings and lists
 of strings in Python. Errors are reported as exceptions rather than integer
 errno-style error codes.  The wrapper takes care to provide one-to-many
 mapping of the error codes to the exceptions by interpreting a context
 in which the error code is produced.

Package: openzfs-pyzfs-doc
Section: contrib/doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Recommends: openzfs-python3-pyzfs
Replaces: pyzfs-doc
Conflicts: pyzfs-doc
Description: wrapper for libzfs_core C library (documentation)
 libzfs_core is intended to be a stable interface for programmatic
 administration of ZFS. This wrapper provides one-to-one wrappers for
 libzfs_core API functions, but the signatures and types are more natural to
 Python.
 .
 nvlists are wrapped as dictionaries or lists depending on their usage.
 Some parameters have default values depending on typical use for
 increased convenience. Enumerations and bit flags become strings and lists
 of strings in Python. Errors are reported as exceptions rather than integer
 errno-style error codes.  The wrapper takes care to provide one-to-many
 mapping of the error codes to the exceptions by interpreting a context
 in which the error code is produced.
 .
 This package contains the documentation.

Package: openzfs-zfs-dkms
Architecture: all
Depends: dkms (>> 2.1.1.2-5),
         file,
         libc6-dev | libc-dev,
         lsb-release,
         python3 (>> 3.12) | python3-distutils | libpython3-stdlib (<< 3.6.4),
         ${misc:Depends},
         ${perl:Depends}
Recommends: openzfs-zfs-zed, openzfs-zfsutils (>= ${source:Version}), ${linux:Recommends}
# suggests debhelper because e.g. `dkms mkdeb -m zfs -v 0.8.2` needs dh_testdir (#909183)
Suggests: debhelper
Breaks: spl-dkms (<< 0.8.0~rc1)
Replaces: spl-dkms, zfs-dkms
Provides: openzfs-zfs-modules
Description: OpenZFS filesystem kernel modules for Linux
 OpenZFS is a storage platform that encompasses the functionality of
 traditional filesystems and volume managers. It supports data checksums,
 compression, encryption, snapshots, and more.
 .
 This DKMS package includes the SPA, DMU, ZVOL, and ZPL components of
 OpenZFS.

Package: openzfs-zfs-initramfs
Architecture: all
Depends: busybox-initramfs | busybox-static | busybox,
         initramfs-tools,
         openzfs-zfs-modules | openzfs-zfs-dkms,
         openzfs-zfsutils (>= ${source:Version}),
         ${misc:Depends}
Breaks: zfsutils-linux (<= 0.7.11-2)
Replaces: zfsutils-linux (<= 0.7.11-2), zfs-initramfs
Conflicts: zfs-initramfs
Description: OpenZFS root filesystem capabilities for Linux - initramfs
 OpenZFS is a storage platform that encompasses the functionality of
 traditional filesystems and volume managers. It supports data checksums,
 compression, encryption, snapshots, and more.
 .
 This package adds OpenZFS to the system initramfs with a hook
 for the initramfs-tools infrastructure.

Package: openzfs-zfs-dracut
Architecture: all
Depends: dracut,
         openzfs-zfs-modules | openzfs-zfs-dkms,
         openzfs-zfsutils (>= ${source:Version}),
         ${misc:Depends}
Conflicts: zfs-dracut
Replaces: zfs-dracut
Description: OpenZFS root filesystem capabilities for Linux - dracut
 OpenZFS is a storage platform that encompasses the functionality of
 traditional filesystems and volume managers. It supports data checksums,
 compression, encryption, snapshots, and more.
 .
 This package adds OpenZFS to the system initramfs with a hook
 for the dracut infrastructure.

Package: openzfs-zfsutils
Section: contrib/admin
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: openzfs-libnvpair3 (= ${binary:Version}),
         openzfs-libuutil3 (= ${binary:Version}),
         openzfs-libzfs4 (= ${binary:Version}),
         openzfs-libzpool5 (= ${binary:Version}),
         python3,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: lsb-base, openzfs-zfs-modules | openzfs-zfs-dkms, openzfs-zfs-zed
Breaks: openrc,
        spl (<< 0.7.9-2),
        spl-dkms (<< 0.8.0~rc1),
        openzfs-zfs-dkms (<< ${source:Version}),
        openzfs-zfs-dkms (>> ${source:Version}...)
Replaces: spl (<< 0.7.9-2), spl-dkms, zfsutils-linux
Conflicts: zfs, zfs-fuse, zfsutils-linux
Suggests: nfs-kernel-server,
          samba-common-bin (>= 3.0.23),
          openzfs-zfs-initramfs | openzfs-zfs-dracut
Provides: openzfsutils
Description: command-line tools to manage OpenZFS filesystems
 OpenZFS is a storage platform that encompasses the functionality of
 traditional filesystems and volume managers. It supports data checksums,
 compression, encryption, snapshots, and more.
 .
 This package provides the zfs and zpool commands to create and administer
 OpenZFS filesystems.

Package: openzfs-zfs-zed
Section: contrib/admin
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: openzfs-zfs-modules | openzfs-zfs-dkms,
         openzfs-zfsutils (>= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: zfs, zfs-zed
Replaces: zfs-zed
Description: OpenZFS Event Daemon
 OpenZFS is a storage platform that encompasses the functionality of
 traditional filesystems and volume managers. It supports data checksums,
 compression, encryption, snapshots, and more.
 .
 ZED (ZFS Event Daemon) monitors events generated by the ZFS kernel
 module. When a zevent (ZFS Event) is posted, ZED will run any ZEDLETs
 (ZFS Event Daemon Linkage for Executable Tasks) that have been enabled
 for the corresponding zevent class.
 .
 This package provides the OpenZFS Event Daemon (zed).

Package: openzfs-zfs-test
Section: contrib/admin
Architecture: linux-any
Depends: acl,
         attr,
         bc,
         fio,
         ksh,
         lsscsi,
         mdadm,
         parted,
         python3,
         openzfs-python3-pyzfs,
         sudo,
         sysstat,
         openzfs-zfs-modules | openzfs-zfs-dkms,
         openzfs-zfsutils (>=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: nfs-kernel-server
